; GRDb
;
; Copyright(c) LADsoft
;
; David Lindauer, gclind01@starbase.spd.louisville.edu
;
;
; DOS.ASM
;
; Function: DOS interfac
;
	;MASM MODE
	.MODEL SMALL
	.386


include  prints.ase 
include env.ase
include  mtrap.ase 
include memory.ase
include options.ase
include loader.ase
include ints.ase
include breaks.ase
include swift.ase

THANDLE = 16
	PUBLIC SetUserPSP, SetDebugPSP, userpsp, UnloadProgram
	PUBLIC int20handle,int21handle, KillFiles, InitHandles
	PUBLIC int1bh,dxbrk

	extrn	trapcount : dword
	.data
dxbrk	db	0
userpsp	dw	0
htab	db	THANDLE DUP (-1)
	.CODE
;
; PSP switching
;
SetDebugPSP	PROC
	mov	ah,51h
	int	21h
	mov	[userpsp],bx
	mov	bx,[psp]
	jmp	sup_2
SetDebugPSP	ENDP
SetUserPSP	PROC
	mov	bx,[userpsp]
sup_2:
	mov	ah,50h
	int	21h
	ret
SetUserPSP	ENDP
;
; ctrl-break handling
;
int1bh	PROC
	pushf
	push	es
	push	bp
	call	untrace
int1bcont:
	mov	bp,dgroup
	mov	es,bp
	mov	es:[dxbrk],1		; assume in dos
	push	es
	les	bp,es:[indos]
	test	byte ptr es:[bp],-1
	pop	es
	jnz	int1bhid		; in dos is easy, break when it exits
					; via int 21h handler
	mov	es:[dxbrk],0		; else start a single step handler
	push	0
	pop	es
	mov	word ptr es:[4],offset _text: stepper ; don't worry about killing
	mov	word ptr es:[6],cs	; primary tracer, it will get fixed
	mov	bp,sp
	or	word ptr [bp + 6 + 4],0100h
int1bhid:
	pop	bp
	pop	es
	popf
	iret
;
; ctrl-break single-stepper.  When ctrl-break comes in the IRET frame
; on the stack will point into the BIOS area.  The following routine
; single-steps the processor until we are out of the BIOS and back
; in the area bounded by GRDB's PSP and the EOM
;

stepper:
	pushf
	push	es
	push	bp
	mov	bp,sp
	les	bp,[bp + 6]			; if next inst is IRET
	cmp	byte ptr es:[bp],0cfh
	jnz	int1bpopf
	mov	bp,sp
	or	word ptr [bp + 4 + 6 +6],100h; set trace flag in frame
	jmp	int1bhid
int1bpopf:
	cmp	byte ptr es:[bp],9dh		; if is POPF
	jnz	stepperfin
	mov	bp,sp
	or	word ptr [bp +6 + 6],100h	; set trace flag
	jmp	int1bhid
stepperfin:
	mov	bp,dgroup			; else check if in
	mov	es,bp				; bounds yet
	mov	bp,sp
	mov	bp,[bp + 2 + 6]
	cmp	bp,es:[psp]
	jb	int1bhid
	mov	es,es:[psp]
	mov	bp,sp
	mov	bp,[bp + 2 + 6]
	cmp	bp,es:[2]
	jae	int1bhid
	mov	bp,sp
	and	word ptr [bp +4 + 6],NOT 100h	; finally in bounds, off tracing
	mov	bp,dgroup
	mov	es,bp
	mov	es:[dxbrk],1
	les	bp,es:[indos]			; just make sure about DOS
	test	byte ptr es:[bp],-1
	jnz	int1bhid			; run to completion if so
	push	ax				; else clear pending ints
	mov	al,20h
	out	20h,al
	pop	ax
	pop	bp
	pop	es
	popf
	jmp	entry1				; return to debugger

int1bh	ENDP
;
; check if we have a proper exit PSP, if we don't assume a spawn
; in progress
;
checkpsp	proc
	push	ds
	push	ax
	push	bx
	mov	ax,dgroup
	mov	ds,ax
	mov	ah,51h
	pushf
	call	cs:[int21adr]
	cmp	bx,[userbasepsp]
	pop	bx
	pop	ax
	pop	ds
	ret
checkpsp	endp
;
; int 20h exit
;
int20handle	PROC
	call	checkpsp
	jz	x20
    	jmp	cs:[int20adr]
x20:
	mov	ax,dgroup
	mov	ds,ax
	mov	es,ax
	mov	bp,sp
	mov	ax,[bp+2]
	cmp	ax,[userbasepsp]
	jz	close20
	Msg	<13,10,"Warning : Int 20h with CS <> PSP (program will crash)">
close20:
	JMP	int21exit0
int20handle	ENDP
;
; int 21h handler.  Hooks 4ch,00h, 2521,3521,
; and exits to debugger if ctrl-break pressed
;
int21handle	PROC
	cmp	ah,4ch
	jz	int21exit4ch
	cmp	ah,0
	jz	int21exit0
	cmp	ax,2521h			; hook setting 21h
	jnz	chk35
	mov	word ptr cs:[int21adr],dx
	mov	word ptr cs:[int21adr+2],ds
	jmp	didvect

chk35:
	cmp	ax,3521h			; hooking reading int 21h
	jnz	normchain
	mov	bx,word ptr cs:[int21adr]
	mov	es,word ptr cs:[int21adr+2]
didvect:
	push	bx			; we have to get the flags back now
	push	bp
	mov	bp,sp       		;
	mov	bx,[bp +4+4]		;
	xchg	bx,[bp+2]
	pop	bp
	jmp	int21join

normchain:
	push	bx			; we have to get the ie flag back
	push	bp
	mov	bp,sp       		; all this is a grandiose simulated
	mov	bx,[bp +4+4]		; interrupt
	xchg	bx,[bp+2]
	pop	bp
	call	cs:[int21adr]		; call DOS
	pushf
int21join:
	push	bp
	push	es
	mov	bp,dgroup		; check for ctrl-break
	mov	es,bp
	test	es:[dxbrk],1
	pop	es
	jnz	i21brk			; yep- go to DOS
	pop	bp
	popf				; NO, RETURN
	retf	2
i21brk:
	mov	bp,sp
	push	ax
	xchg	ax,[bp+2]                ; get DOS return flags to stack
	mov	[bp+2+6],ax		; and hit the debugger
	pop	ax
	pop	bp
	add	sp,2
	jmp	entry1
;
; DOS exit request comes here
;
	
int21exit0:
	sub	ax,ax
int21exit4ch:
	call	checkpsp
	jnz	normchain
	cld
	call	untrace
	mov	bx,dgroup
	mov	ds,bx
	mov	es,bx
	mov	ss,[stackseg]
	mov	sp,[stackofs]
	sti
	mov	[trapcount],0
	mov	[dxbrk],0
	push	ax
	call	SetDebugPSP		; debug PSP
	mov	si,offset dgroup : veclist	; unhook ints
	call	ReleaseRMInts
	call	disableBreaks	; Disable breakpoints if not
	Msg	<13,10,"Normal exit, exit code: ">
	pop	ax
	call	PrintByte	; error code
	call	crlf
	call	UnLoadProgram	; unload the program
	test	[lastexe],0ffh	; see if was EXE
	jz	rex
	mov	ax,[lastcs]	; yep, refresh CS:EIP
	mov	[drcs],ax
	mov	eax,[lastip]
	mov	[dreip],eax
rex:
	jmp	reentry
;
; unload program
;
UnLoadProgram:
	call	UnLoadInts	; reinit int table
	call	KillFiles	; kill their files
	call	ReleaseMemory	; release memory
	mov	si,offset dgroup : grdbname	; make an empty program
	call	MakeEmptyProg
	ret
int21handle	ENDP
;
; make extended handle table for debugger
;
InitHandles	PROC
	mov	fs,[psp]
	push	ds
	lds	si,fs:[34h]
	mov	cx,fs:[32h]
	cmp	cx,THANDLE
	jc  	nofix
	mov	cx,THANDLE
nofix:
	mov	fs:[32h],cx
	mov	di,offset dgroup:htab
	rep	movsb
	pop	ds
	mov	word ptr fs:[34h],offset dgroup:htab
	mov	fs:[36h],ds
	ret
InitHandles	ENDP
;
; kill program files by reading the handle table and closing them all
;
KillFiles PROC
	call	SetUserPSP
	mov	fs,bx
	mov	ah,50h
	int	21h
	mov	cx,fs:[32h]
kf_lp:
	mov	bx,cx
	dec	bx
	mov	ah,3eh
	int	21h
	loop	kf_lp
	call	SetDebugPSP
	ret
KillFiles	ENDP
end