;
; GRDP
;
; Copyright(c) LADsoft
;
; David Lindauer, gclind01@starbase.spd.louisville.edu
;
; ENV.ASM
;
; Function : environment handling
;
	.model small
	.386

include mtrap.ase
include memory.ase

	public CopyEnv, envseg, SetEnvName, QualifyName
	public envused,envseg,envlen,progname

	.data
envseg	dw	0
envlen	dw	0
envused dw	0
progname dw	0
fname	db	0,':\',77 DUP (0)
	.code
;
; create memory for their env
;
MakeEnv	PROC
	mov	fs,[psp]
	mov	ax,fs:[2ch]
	dec	ax
	mov	fs,ax
	mov	bx,fs:[3]
	add	bx,8		; add space so we can be sure prog path will fit
	mov	[envlen],bx
	shl	[envlen],4
	mov	ah,48h
	int	21h
	jc	me_err
	mov	[envseg],ax
	clc
me_err:
	ret
MakeEnv	ENDP
;
; copy our env to their space
;
CopyEnv PROC
	push	si
	call	MakeEnv
	pop	si
	jc	cm_err
	push	es
	push	ds
	push	si
	mov	es,[envseg]
	mov	ds,[psp]
	mov	ds,ds:[2ch]
	sub	di,di
	sub	si,si
ce_lp:
	lodsb
	stosb
	or	al,al
	jnz	ce_lp
	lodsb
	stosb
	or	al,al
	jnz	ce_lp
	mov	ax,1
	stosw
	pop	si
	pop	ds
	pop	es
	mov	[progname],di
SetEnvName	PROC
	mov	di,[progname]	; subroutine to tag the name with the env
	push	es
	mov	es,[envseg]
	push	si
sevl:
	lodsb
	stosb
	or	al,al
	jnz	sevl
	pop	si
	pop	es
	mov	[envused],di
       	clc
cm_err:
	ret
SetEnvName	ENDP
CopyEnv ENDP
;
; qualify the name with a full path
;
; will parse '..' sequences if they come FIRST
;
qualifyname	PROC
	test	byte ptr [si],0ffh	; no file name, get out
	jz	qnx
	push	si 			; get drive
	mov	ah,19h
	int	21h
	add	al,'A'
	mov	[fname],al
	sub	dl,dl
	mov	ah,47h			; now get path
	mov	si,offset dgroup:fname+3
	int	21h
	mov	di,si
	sub	di,3
	mov	cx,-1
	sub	al,al
	repnz	scasb
	dec	di
	mov	al,'\'			; append '\' char
	stosb
	pop	si
	push	si
qnl1:
	cmp	byte ptr [si],'.'	; check for ..
	jnz	nback
	cmp	byte ptr [si+1],'.'
	jnz	nback
	dec	di   			; yep, scan back past last dir
	dec	di
	std
	mov	al,'\'
	repnz	scasb
	cld
	add	di,2			; and loop
	add	si,3
	jmp	qnl1
nback:
	lodsb				; now do string copy
	stosb
	or	al,al
	jnz	nback
	pop	di			; copy it back to the orig buf
	mov	si, offset dgroup:fname
qnl2:
	lodsb
	stosb
	or	al,al
	jnz	qnl2
qnx:
	ret
qualifyname	ENDP
	end