;
; GRDP
;
; Copyright(c) LADsoft
;
; David Lindauer, gclind01@starbase.spd.louisville.edu
;
;
; HISTORY.ASM
;
; Function: Handle command line history
;
	;MASM MODE
	.MODEL SMALL
	.386
HISTSIZE EQU 128	; MUST be longer than longest command line!!!!

include  prints.ase 
include  input.ase 
include  mtrap.ase 
include  breaks.ase 
include  loader.ase
include  dos.ase
include options.ase
include exec.ase
include memory.ase
include logging.ase

	PUBLIC CheckHistory, EnterHistory, LoadHistory
	.data
oldhistory db	0
histlen dw	0
histseg dw	0
histpos dw	0
histon	db	13,10,"History enabled",0
histoff	db	13,10,"History disabled",0
histerr	db	13,10,"No mem for history",0
histmsg db	" (History access)",0

	.code
ifdef DOIT
CommandToLog PROC
	mov	bx,offset dgroup : histmsg
	mov	bx,offset dgroup : prompt
cllp:
	mov	al,[bx]
	or	al,al
	jz	clnd
	inc	bx
	call	LogToFile
	jmp	cllp
clnd:

	ret
CommandToLog ENDP
findprev proc
	mov	di,[histpos]
	or	di,di
	jnz	prevnowrap
	add	di,[histlen]

prevnowrap:
	push	cx
	dec	di
	dec	di
	std
	mov	cx,-1
	sub	al,al
	repne	scasb
	inc	di
	cld
	cmp	di,[histpos]
	mov	[histpos],di
	pop	cx
	ret
findprev endp
findnext proc
	push	cx
	mov	di,[histpos]
	mov	cx,-1
	rep	scasb
	cmp	di,[histlen]
	jc	nonextwrap
	sub	di,di
nonextwrap:
	cmp	di,[histpos]
	mov	[histpos],di
	ret
findnext endp
compare proc
	push	cx
	repe	cmpsb
	pop	cx
	ret
compare endp
stringsize proc
	push	di
	push	cx
	mov	cx,-1
	sub	al,al
	rep	scasb
	neg	cx
	dec	cx
	mov	ax,cx
	pop	cx
	pop	di
	ret
stringsize endp
copystring proc
	lodsb
	or	al,al
	jz	csend
	stosb
	jmp	copystring
csend:
	ret
copystring endp
endif

CheckHistory PROC
ifdef doit
	push	si
	test	[oldhistory],1
	jmp	nocheck
	or	al,al
	jnz	nocheck
	push	es
	mov	cx,di
	sub	cx,si
	dec	cx
	cmp	ax,4800h
	jz	up
	cmp	ax,5000h
	jnz	nocheck
down:
	push	es
downlp:
	mov	es,[histseg]
	mov	bx,[histpos]
	mov	di,bx
	call	compare
	je	downfound
	call	findprev
	jnz	downlp
	jmp	okcheck
downfound:
	mov	dx,[histpos]
	call	findprev
	pop	es
	jmp	found
up:
	push	es
uplp:
	mov	es,[histseg]
	mov	bx,[histpos]
	mov	di,bx
	call	compare
	je	upfound
	call	findnext
	jnz	uplp
	jmp	okcheck
upfound:
	mov	dx,[histpos]
	call	findnext
	pop	es
found:
	push	ds
	mov	ds,[histseg]
	mov	si,dx
	mov	di,offset dgroup : inputbuffer
	call	copystring
	pop	ds
okcheck:
	pop	si
	stc
	ret

nocheck:
	pop	si
endif
	clc
	ret
CheckHistory ENDP
EnterHistory PROC
ifdef doit
	test	[oldhistory],1
	jz	noenter
	mov	cx,di
	sub	cx,si
	cmp	cx,1
	jz	noenter
	int 3
	push	es
	push	si
	mov	es,[histseg]
	sub	di,di
ehsl:
	mov	ax,HISTSIZE
	sub	ax,[histlen]
	sub	ax,cx
	jnc	enoughroom
	push	cx
	call	stringsize
	mov	cx,HISTSIZE
	sub	cx,[histlen]
	sub	cx,ax
	mov	si,di
	add	si,ax
	push	ds
	mov	ds,[histseg]
	rep	movsb
	pop	ds
	sub	[histlen],ax
	pop	cx
	jmp	ehsl
enoughroom:
	mov	di,[histlen]
	pop	si
	push	si
	push	di
	add	[histlen],cx
	rep	movsb
	mov	byte ptr es:[di-1],0
	pop	di
	pop	es
	mov	[histpos],0
	pop	si
noenter:
	endif
	ret
EnterHistory ENDP
LoadHistory PROC
	sub	ah,ah
ifdef	DOIT
	mov	al,[opthist]
	cmp	al,[oldhistory]
	jz	nochange
	call	KillFiles
	call	ReleaseMemory
	test	[opthist],0ffh
	jnz	doload
	push	es
	mov	es,[histseg]
	mov	ah,49h
	int	21h
	mov	[oldhistory],0
	pop	es
	mov	bx,offset dgroup : histoff
	jmp	reload
doload:
	mov	bx,HISTSIZE SHR 4
	mov	ax,4800h
	int	21h
	mov	bx, offset dgroup :histerr
	mov	[opthist],0
	jc	reload
	mov	[oldhistory],1
	mov	[opthist],1
	mov	[histseg],ax
	mov	[histlen],0
	mov	[histpos],0
	mov	bx, offset dgroup : histon
reload:
	call	olMessage
	mov	si,offset dgroup : grdbname
	call	MakeEmptyProg
	sub	ax,ax
	test	[loadfile],0ffh
	jz	nochange
	call	LoadProgram
	lahf
nochange:
ENDIF
	ret
LoadHistory ENDP

end