;
; GRDP
;
; Copyright(c) LADsoft
;
; David Lindauer, gclind01@starbase.spd.louisville.edu
;
;
; MATH.ASM
;
; Function: Handle hex math
;
	;MASM MODE
	.MODEL SMALL
	.386


include  prints.ase 
include  input.ase 
include  mtrap.ase 
include  breaks.ase 
include  options.ase
	PUBLIC domath

	.CODE
;
; Do math
;
printx	PROC
	test	[optdword],1
	jnz	PrintDword
	jmp	PrintWord
printx	ENDP
domath	PROC	
	Call	WadeSpace	; Wade till address
	jc	readerr
	call	ReadNumber	; first number
	jc	readerr
	mov	edx,eax
	call	WadeSpace	; get operator
	jz	readerr
	sub	ebx,ebx
	cmp	al,'*'
	jz	got
	inc	bl
	cmp	al,'/'
	jz	got
	inc	bl
	cmp	al,'+'
	jz	got
	inc	bl
	cmp	al,'-'
	jz	got
	inc	bl
	cmp	al,'%'
	jz	got
	dec	si
	mov	bl,2		; default operator = +
got:
	inc	si
	call	WadeSpace
	jz	readerr
	call	ReadNumber	; second number
	jc	readerr
	mov	ecx,eax
	call	WadeSpace
	jnz	readerr
	shl	bl,1		; execute operand
	mov	eax,edx
	call	cs:[bx + jumptab]
	push	eax
	call	crlf
	pop	eax
	call	printx		; print result
	clc
	ret
jumptab	dw	xmul,xdiv,xxadd,xsub,xmod
xmul:
	mul	ecx
	ret
xmod:
	call	xdiv
	mov	eax,edx
	ret
xdiv:
	or	eax,eax
	jz	nodiv
	sub	edx,edx
	div	ecx
nodiv:
	ret
xxadd:
	add	eax,ecx
	ret
xsub:
	sub	eax,ecx
	ret
readerr:
	stc
	ret
domath	ENDP
end