;
; GRDP
;
; Copyright(c) LADsoft
;
; David Lindauer, gclind01@starbase.spd.louisville.edu
;
;
; SEARCH.ASM
;
; Function: Search memory
;
	;MASM MODE
	.MODEL SMALL
	.386


include  prints.ase 
include  input.ase 
include  mtrap.ase 

	PUBLIC search
	.data
count	dw	0


	.CODE
search	PROC
	push	es
	mov	[count],0
	call	WadeSpace
	jz	errx
	call	ReadAddress	; read address
	jc	errx
	mov	cx,bx
	or	edx,edx
	jnz	hasseg
	mov	dx,[drds]
hasseg:
	call	WadeSpace
	jz	errx
	push	cx
	mov	di,dx
	push	di
	call	ReadAddress	; read len
	pop	di
	pop	cx
	jc	errx
	or	edx,edx
	jnz	hasseg2
	mov	dx,[drds]
hasseg2:
	mov	bx,ax
	mov	es,[psp]
	push	di
	mov	di,80h
grablp:				; read rest of params
	call	WadeSpace
	jz	grabdone
	cmp	al,"'"
	jz	readstring
	cmp	al,'"'
	jnz	readnum
readstring:             	; read a quoted string
	inc	si
readstringlp:
	lodsb
	cmp	al,13
	jz	grabdone
	cmp	al,'"'
	jz	grablp
	cmp	al,"'"
	jz	grablp
	stosb
	inc	[count]
	cmp	[count],080h
	jnc	errx
	jmp	readstringlp

readnum:			; read an (8-bit) number
	push	di
	push	cx
	call	ReadNumber
	pop	cx
	pop	di
	jc	errx2
	stosb
	inc	[count]
	cmp	[count],080h
	jnc	errx
	jmp	grablp

grabdone:                       	; all params got now
	pop	di
	test	[count],0ffh		; see if any search
	jz	errx
	movzx	eax,dx 			; calculate length
	shl	eax,4
	movzx	ebx,bx
	add	ebx,eax
	movzx	edx,di
	mov	eax,edx
	shl	eax,4
	movzx	ecx,cx
	add	eax,ecx
	sub	ebx,eax			; ds:cx = start, ebx = len
	push	ebx
	call	CRLF
	pop	ebx
	pop	es
	mov	si,cx
noseg:
	cmp	si,8000h	; adjust DS to keep search in bounds
	jc	go1
	sub	si,8000h
    	add	dx,800h
go1:
	call	ScanKey		; I put this in for debug, but,
	jnz	nofill2		; good for mistakes too...
	push	es
	mov	es,[psp]
	mov	cx,[count]
	push	ds
	mov	ds,dx
	push	si
	mov	di,80h
	repe	cmpsb
	pop	si
	pop	ds
	pop	es
	jnz	nomatch
	push	ebx
	mov	ax,dx		; match, display address
	call	PrintWord
	push	dx
	mov	dl,':'
	call	putchar
	pop	dx
	mov	ax,si
	call	PrintWord
	call	crlf
	pop	ebx
nomatch:
	inc	si
	dec	ebx
	jne	noseg
	clc
	ret
nofill:
	pop	es
nofill2:
	clc
	ret
errx2:
	pop	di
errx:
	pop	es
	stc
	ret
search	endp
end